
#include <stdlib.h>
#include <stdio.h>
#include "hash.h"


//
// get_tree_mem
//
// Check to see if there is a free tree node in the free list.  If so,
// reuse it for the newly allocated has element.  If not, call the
// virtual function get_mem to allocate a new tree node.
//
binary_tree::bi_tree_ptr hash::get_tree_mem(void)
{
  binary_tree::bi_tree_ptr retptr;

  retptr = (bi_tree_ptr)get_from_free_list();
  if (retptr == NULL) {
    retptr = (bi_tree_ptr)get_mem( sizeof( bi_tree ) );
  }
  return retptr;
}



void *hash::get_mem( unsigned int num_bytes )
{
  printf("hash::get_mem: no virtual function for this class\n");
  return NULL;
}



//
// Use a shift algorithm to distribute the key (e.g., make it more
// pseudo-random).  I actually tried several different algorithms to
// do this and this one worked the best.  It was suggested by
// Brent Gregory at Synopsys, although any mistakes in translating his 
// suggestion to code are mine.  The code below is a loop, which has
// been in-lined for speed.
//
unsigned int hash::hash_value( unsigned int val )
{
  unsigned int new_val;

  new_val = val ^ (val << 1);
  new_val = new_val ^ (val << 2);
  new_val = new_val ^ (val << 3);
  new_val = new_val ^ (val << 4);
  new_val = new_val ^ (val << 5);
  new_val = new_val ^ (val << 6);
  new_val = new_val ^ (val << 7);
  new_val = new_val ^ (val << 8);
  new_val = new_val ^ (val << 9);
  new_val = new_val ^ (val << 10);
  new_val = new_val ^ (val << 11);
  new_val = new_val ^ (val << 12);
  new_val = new_val ^ (val << 13);
  new_val = new_val ^ (val << 14);
  new_val = new_val ^ (val << 15);
  new_val = new_val ^ (val << 16);
  return new_val;
} // hash
